// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "CameraTexture.hpp"

using namespace Dawn;

CameraTexture::CameraTexture(SceneItem *item) :
  SceneItemComponent(item),
  camera(nullptr)
{
  renderTarget = std::make_shared<TextureRenderTarget>(32, 32);
}

void CameraTexture::onStart() {
  if(this->camera == nullptr) this->camera = item->getComponent<Camera>();

  useEffect([&]{
    if(this->camera == nullptr) return;
    this->camera->renderTarget = this->renderTarget;
  }, camera)();
}